/*
 * Copyright (c) 2019, MediaTek Inc. All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef RTC_H
#define RTC_H

/* RTC registers */
enum {
	RTC_BBPU = 0x0588,
	RTC_IRQ_STA = 0x058A,
	RTC_IRQ_EN = 0x058C,
	RTC_CII_EN = 0x058E
};

enum {
	RTC_AL_SEC = 0x05A0,
	RTC_AL_MIN = 0x05A2,
	RTC_AL_HOU = 0x05A4,
	RTC_AL_DOM = 0x05A6,
	RTC_AL_DOW = 0x05A8,
	RTC_AL_MTH = 0x05AA,
	RTC_AL_YEA = 0x05AC,
	RTC_AL_MASK = 0x0590,
	RTC_TC_SEC = 0x0592,
	RTC_TC_MIN = 0x0594,
	RTC_TC_HOU = 0x0596,
	RTC_TC_DOM = 0x0598,
	RTC_TC_DOW = 0x059A,
	RTC_TC_MTH = 0x059C,
	RTC_TC_YEA = 0x059E,
};

enum {
	RTC_OSC32CON = 0x05AE,
	RTC_CON = 0x05C4,
	RTC_WRTGR = 0x05C2
};

enum {
	RTC_POWERKEY1 = 0x05B0,
	RTC_POWERKEY2 = 0x05B2,
	RTC_PDN1 = 0x05B4,
	RTC_PDN2 = 0x05B6,
	RTC_SPAR0 = 0x05B8,
	RTC_SPAR1 = 0x05BA,
	RTC_PROT = 0x05BC,
	RTC_DIFF = 0x05BE,
	RTC_CALI = 0x05C0
};

enum {
	RTC_OSC32CON_UNLOCK1 = 0x1A57,
	RTC_OSC32CON_UNLOCK2 = 0x2B68
};

enum {
	RTC_POWERKEY1_KEY = 0xA357,
	RTC_POWERKEY2_KEY = 0x67D2,
};

enum {
	RTC_PROT_UNLOCK1 = 0x586A,
	RTC_PROT_UNLOCK2 = 0x9136
};

enum {
	RTC_BBPU_PWREN	= 1U << 0,
	RTC_BBPU_CLR	= 1U << 1,
	RTC_BBPU_INIT	= 1U << 2,
	RTC_BBPU_AUTO	= 1U << 3,
	RTC_BBPU_CLRPKY	= 1U << 4,
	RTC_BBPU_RELOAD	= 1U << 5,
	RTC_BBPU_CBUSY	= 1U << 6
};

enum {
	RTC_AL_MASK_SEC = 1U << 0,
	RTC_AL_MASK_MIN = 1U << 1,
	RTC_AL_MASK_HOU = 1U << 2,
	RTC_AL_MASK_DOM = 1U << 3,
	RTC_AL_MASK_DOW = 1U << 4,
	RTC_AL_MASK_MTH = 1U << 5,
	RTC_AL_MASK_YEA = 1U << 6
};

enum {
	RTC_BBPU_AUTO_PDN_SEL = 1U << 6,
	RTC_BBPU_2SEC_CK_SEL = 1U << 7,
	RTC_BBPU_2SEC_EN = 1U << 8,
	RTC_BBPU_2SEC_MODE = 0x3 << 9,
	RTC_BBPU_2SEC_STAT_CLEAR = 1U << 11,
	RTC_BBPU_2SEC_STAT_STA = 1U << 12
};

enum {
	RTC_BBPU_KEY	= 0x43 << 8
};

enum {
	RTC_EMBCK_SRC_SEL	= 1 << 8,
	RTC_EMBCK_SEL_MODE	= 3 << 6,
	RTC_XOSC32_ENB		= 1 << 5,
	RTC_REG_XOSC32_ENB	= 1 << 15
};

enum {
	RTC_K_EOSC_RSV_0	= 1 << 8,
	RTC_K_EOSC_RSV_1	= 1 << 9,
	RTC_K_EOSC_RSV_2	= 1 << 10
};

#define RTC_CALI_BBPU_2SEC_EN		(1U << 8)
#define RTC_CALI_BBPU_2SEC_MODE_SHIFT	9
#define RTC_CALI_BBPU_2SEC_MODE_MSK	(3U << RTC_CALI_BBPU_2SEC_MODE_SHIFT)
#define RTC_CALI_BBPU_2SEC_STAT		(1U << 11)

#define RTC_GP_OSC32_CON		(2U << 13)
#define RTC_EOSC32_VCT_EN		(1U << 11)
#define RTC_EOSC32_CHOP_EN 		(1U << 12)
#define RTC_EMBCK_SEL_K_EOSC	 	(1U << 6)
#define RTC_EMBCK_SEL_OPTION		(1U << 9)
#define RTC_GPS_CKOUT_EN		(1U << 10)
#define RTC_OSC32CON_ANALOG_SETTING		(RTC_GP_OSC32_CON | \
						RTC_EOSC32_CHOP_EN | \
						RTC_EOSC32_VCT_EN | \
						RTC_GPS_CKOUT_EN | \
						RTC_EMBCK_SEL_OPTION | \
						RTC_EMBCK_SEL_K_EOSC)
#define RTC_FQMTR_RST			(1U << 8)
#define RTC_FQMTR_BUSY			(1U << 3)
#define RTC_FQMTR_EN			(1U << 15)
#define RTC_XOSCCALI_START		0x0000
#define RTC_XOSCCALI_END		0x001f

#define PMIC_FQMTR_DCXO26M_EN_MASK	1
#define PMIC_FQMTR_DCXO26M_EN_SHIFT	4
#define FQMTR_DCXO26M_EN		(1U << PMIC_FQMTR_DCXO26M_EN_SHIFT)

#define PMIC_RG_FQMTR_CK_PDN_MASK	0x1
#define PMIC_RG_FQMTR_CK_PDN_SHIFT	11
#define PMIC_RG_FQMTR_32K_CK_PDN_MASK	0x1
#define PMIC_RG_FQMTR_32K_CK_PDN_SHIFT	10
#define PMIC_RG_FQMTR_CK_CKSEL_MASK	0x7
#define PMIC_RG_FQMTR_CK_CKSEL_SHIFT	0
#define FQMTR_FIX_CLK_EOSC_32K		(2 << PMIC_RG_FQMTR_CK_CKSEL_SHIFT)
#define	FQMTR_FQM26M_CK 		4
#define RTC_FQMTR_LOW_BASE		(794 - 2)
#define RTC_FQMTR_HIGH_BASE		(794 + 2)
#define FQMTR_FIX_CLK_26M		(0 << PMIC_RG_FQMTR_CK_CKSEL_SHIFT)
#define FQMTR_FIX_CLK_XOSC_32K_DET	(1 << PMIC_RG_FQMTR_CK_CKSEL_SHIFT)
#define FQMTR_XOSC32_CK			0
#define	FQMTR_DCXO_F32K_CK 		1
#define RTC_CON_LPSTA_RAW		(1U << 15)
#define RTC_CON_LPRST			(1U << 3)
#define RTC_XOSC32_LPEN			(1U << 2)
#define RTC_EOSC32_LPEN			(1U << 1)
#define RTC_CON_GPU			(1U << 11)
#define RTC_CON_F32KOB			(1U << 5)
#define RTC_CON_GPEN			(1U << 10)
#define RTC_CON_GOE			(1U << 7)
#define RTC_PDN1_DEBUG			(1U << 15)
#define RTC_PDN1_BYPASS_PWR		(1U << 6)
#define RTC_PDN1_FAC_RESET		(1U << 4)
#define RTC_BBPU_2SEC_MODE_MSK		(3U << 9)
#define RTC_BBPU_2SEC_MODE_SHIFT	(9)
#define RTC_PDN2_AUTOBOOT		(1U << 7)
#define RTC_IRQ_STA_AL			(1U << 0)
#define RTC_PDN1_PWRON_TIME		(1U << 7)
#define RTC_MIN_YEAR			1968
#define RTC_SPAR0_PWRON_SEC_MASK	0x003f
#define RTC_SPAR0_PWRON_SEC_SHIFT	0
#define RTC_SPAR1_PWRON_MIN_MASK	0x003f
#define RTC_SPAR1_PWRON_MIN_SHIFT	0
#define RTC_SPAR1_PWRON_HOU_MASK	0x07c0
#define RTC_SPAR1_PWRON_HOU_SHIFT	6
#define RTC_SPAR1_PWRON_DOM_MASK	0xf800
#define RTC_SPAR1_PWRON_DOM_SHIFT	11
#define RTC_PDN2_PWRON_MTH_MASK		0x000f
#define RTC_PDN2_PWRON_MTH_SHIFT	0
#define RTC_PDN2_PWRON_YEA_MASK		0x7f00
#define RTC_PDN2_PWRON_YEA_SHIFT	8
#define RTC_PDN2_PWRON_LOGO		(1U << 15)
#define RTC_PDN2_PWRON_ALARM		(1U << 4)
#define RTC_PDN2_UART_MASK		0x0060
#define RTC_PDN2_UART_SHIFT		5
#define RTC_AL_YEA_MASK			(0X7F << 0)
#define RTC_NEW_SPARE3			(0xFF << 8)
#define RTC_NEW_SPARE1			(0xFF << 8)
#define RTC_NEW_SPARE0			(0xFF << 8)
#define RTC_AL_SEC_MASK			(0x3F)

#define RTC_IRQ_EN_AL			(1U << 0)
#define RTC_IRQ_EN_TC			(1U << 1)
#define RTC_IRQ_EN_ONESHOT		(1U << 2)
#define RTC_IRQ_EN_LP			(1 << 3)
#define RTC_IRQ_EN_ONESHOT_AL		(RTC_IRQ_EN_ONESHOT | RTC_IRQ_EN_AL)
#define RTC_PDN1_RECOVERY_MASK		0x0030
#define RTC_LPD_OPT_F32K_CK_ALIVE	(3U << 13)

#define PMIC_TMA_KEY_ADDR		0x03A8
#define PMIC_TMA_KEY_MASK		0xFFFF
#define PMIC_TMA_KEY_SHIFT		0

#define RTC_DEFAULT_YEA			2010
#define RTC_DEFAULT_MTH			1
#define RTC_DEFAULT_DOM			1
#define RTC_2SEC_REBOOT_ENABLE		0
#define RTC_2SEC_MODE			2
#define RTC_K_EOSC32_VTCXO_ON_SEL	(1 << 15)
#define RTC_POWER_DETECTED		(1 << 12)
#define RTC_K_EOSC_RSV_0		(1U << 8)
#define RTC_K_EOSC_RSV_1		(1U << 9)
#define RTC_K_EOSC_RSV_2		(1U << 10)
#define RTC_K_EOSC_RSV_3		(1U << 11)
#define RTC_K_EOSC_RSV_4		(1U << 12)
#define RTC_K_EOSC_RSV_5		(1U << 13)
#define RTC_K_EOSC_RSV_6		(1U << 14)
#define RTC_K_EOSC_RSV_7		(1U << 15)
#define RTC_75K_TO_32K			(1U << 3)

#define PMIC_RG_OCTL_RTC_32K1V8_0_ADDR	0x36
#define PMIC_RG_OCTL_RTC_32K1V8_0_MASK	0xF
#define PMIC_RG_OCTL_RTC_32K1V8_0_SHIFT	8

#define PMIC_RTC_LPD_OPT_MASK		0x3
#define PMIC_RTC_LPD_OPT_SHIFT		13

#define RTC_LPD_OPT_SHIFT		(PMIC_RTC_LPD_OPT_SHIFT)
#define RTC_LPD_OPT_MASK		(3 << 13)
#define RTC_LPD_OPT_EOSC_LPD		(1U << PMIC_RTC_LPD_OPT_SHIFT)

#define RTC_SPAR0_32K_LESS		(1U << 6)
#define RTC_GPIO_USER_MASK		(((1U << 13) - 1) & 0xff00)

/* PMIC TOP Register Definition */
enum {
	PMIC_RG_TOP_CON = 0x001E,
	PMIC_RG_TOP_CKPDN_CON0_SET = 0x010E,
	PMIC_RG_TOP_CKPDN_CON0_CLR = 0x0110,
	PMIC_RG_TOP_CKPDN_CON1 = 0x0112,
	PMIC_RG_TOP_CKPDN_CON1_SET = 0x0114,
	PMIC_RG_TOP_CKPDN_CON1_CLR = 0x0116,
	PMIC_RG_TOP_CKSEL_CON0 = 0x0118,
	PMIC_RG_TOP_CKSEL_CON0_SET = 0x011A,
	PMIC_RG_TOP_CKSEL_CON0_CLR = 0x011C,
	PMIC_RG_TOP_RST_CON0 = 0x013E,
};

/* PMIC SCK Register Definition */
enum {
	PMIC_RG_SCK_TOP_CON0 = 0x050C,
	PMIC_RG_FQMTR_CON0 = 0x0514,
	PMIC_RG_FQMTR_CON1 = 0x0516,
	PMIC_RG_FQMTR_CON2 = 0x0518,
	PMIC_RG_SCK_TOP_CKPDN_CON0 = 0x051A,
	PMIC_RG_SCK_TOP_CKPDN_CON0_SET = 0x051C,
	PMIC_RG_SCK_TOP_CKPDN_CON0_CLR = 0x051E,
	PMIC_RG_EOSC_CALI_CON0 = 0x540,
	PMIC_RG_SCK_TOP_XTAL_SEL_MASK = 0x1,
	PMIC_RG_SCK_TOP_XTAL_SEL_SHIFT = 0,
};

/* PMIC DCXO Register Definition */
enum {
	PMIC_RG_DCXO_CW00 = 0x0788,
	PMIC_RG_DCXO_CW02 = 0x0790
};

enum {
	PMIC_RG_SRCLKEN_IN0_HW_MODE_MASK = 0x1,
	PMIC_RG_SRCLKEN_IN0_HW_MODE_SHIFT = 1,
	PMIC_RG_SRCLKEN_IN1_HW_MODE_MASK = 0x1,
	PMIC_RG_SRCLKEN_IN1_HW_MODE_SHIFT = 3,
	PMIC_RG_RTC_EOSC32_CK_PDN_MASK = 0x1,
	PMIC_RG_RTC_EOSC32_CK_PDN_SHIFT = 2,
	PMIC_RG_EOSC_CALI_TD_MASK = 0x7,
	PMIC_RG_EOSC_CALI_TD_SHIFT = 5,
	PMIC_RG_XO_EN32K_MAN_MASK = 0x1,
	PMIC_RG_XO_EN32K_MAN_SHIFT = 0,
	PMIC_RG_XO_XMODE_M_MASK = 0x1,
	PMIC_RG_XO_XMODE_M_SHIFT = 3,
	PMIC_RG_XO_XMODE_MAN_MASK = 0x1,
	PMIC_RG_XO_XMODE_MAN_SHIFT = 2,
	PMIC_RG_XO_EN32K_M_MASK = 0x1,
	PMIC_RG_XO_EN32K_M_SHIFT = 1,
};

/* external API */
uint16_t RTC_Read(uint32_t addr);
void RTC_Write(uint32_t addr, uint16_t data);
int32_t rtc_busy_wait(void);
int32_t RTC_Write_Trigger(void);
int32_t Writeif_unlock(void);
void rtc_power_off_sequence(void);
void rtc_power_on_sequence(void);

#endif /* RTC_H */
